# Koyo2.cmd

< envPaths

dbLoadDatabase("../../dbd/modbus.dbd")
modbus_registerRecordDeviceDriver(pdbbase)

# Use the following commands for TCP/IP
#drvAsynIPPortConfigure(const char *portName,
#                       const char *hostInfo,
#                       unsigned int priority,
#                       int noAutoConnect,
#                       int noProcessEos);
#drvAsynIPPortConfigure("cbm","192.168.30.101:502",0,0,1)
drvAsynIPPortConfigure("cbm","10.160.0.51:502",0,0,1)

#modbusInterposeConfig(const char *portName,
#                      modbusLinkType linkType,
#                      int timeoutMsec, 
#                      int writeDelayMsec)
modbusInterposeConfig("cbm",0,2000,0)

# NOTE: We use octal numbers for the start address and length (leading zeros)
#       to be consistent with the PLC nomenclature.  This is optional, decimal
#       numbers (no leading zero) or hex numbers can also be used.
#       In these examples we are using slave address 0 (number after "Koyo2").

# The DL205 has bit access to the Yn outputs at Modbus offset 4000 (octal)
# Read 32 bits (Y0-Y37).  Function code=1.
drvModbusAsynConfigure("K2_Yn_In_Bit",       "cbm",    0, 3,  0X3000,  0X8,    0,  100,    "beckhoff")

# The DL205 has bit access to the Yn outputs at Modbus offset 4000 (octal)
# Write 32 bits (Y0-Y37).  Function code=5.
drvModbusAsynConfigure("K2_Yn_Out_Bit",      "cbm",    0, 6,  0X3000,  0X8,    0,  1,      "beckhoff")

# The DL205 has bit access to the Cn bits at Modbus offset 6000 (octal)
# Access 256 bits (C0-C377) as inputs.  Function code=1.
drvModbusAsynConfigure("K2_Cn_In_Bit",       "cbm",    0, 3,  0X3000,  0X20,   0,  100,    "beckhoff")

# Access the same 256 bits (C0-C377) as outputs.  Function code=5.
drvModbusAsynConfigure("K1_V3000_Out_Word",  "cbm",    0, 6,  0X30FA,  0X20,   0,  1,      "beckhoff")

# The DL205 has word access to the V3000 memory at Modbus offset 3000 (octal)
# Access 32 words (V3000-V3040) as inputs.  Function code=3, data type signed BCD.
drvModbusAsynConfigure("K2_V3000_In_Word",   "cbm",    0, 3, 0X30C8,  0X20,    0,  100,    "beckhoff")
drvModbusAsynConfigure("K1_V3000_In_Word",   "cbm",    0, 3, 0X30FA,  0X20,    0,  100,    "beckhoff")

# Enable ASYN_TRACEIO_HEX on octet server
#asynSetTraceIOMask("cbm",0,4)
# Enable ASYN_TRACE_ERROR and ASYN_TRACEIO_DRIVER on octet server
#asynSetTraceMask("cbm",0,9)

# Enable ASYN_TRACEIO_HEX on modbus server
#asynSetTraceIOMask("K2_V3000_In_Word",0,4)
#asynSetTraceIOMask("K1_V3000_In_Word",0,4)

# Enable ASYN_TRACE_ERROR, ASYN_TRACEIO_DEVICE, and ASYN_TRACEIO_DRIVER on modbus server
#asynSetTraceMask("K2_V3000_In_Word",0,11)
#asynSetTraceMask("K1_V3000_In_Word",0,11)

#dbLoadTemplate("cbm.substitutions")
dbLoadDatabase("$(TOP)/db/cbm.db")
iocInit

dbl > $(TOP)/$(IOC)/cbm.dbl


